%% VAR-CCM1 (forecasting)

%%  construct Y, X
Y = Data(p+loff:end,:);
[T, n] = size(Y);
longy = reshape(Y',[],1);      
k = n*p + 1;  
X = zeros(T,n*p);
for ii = 1:p
    X(:, ( ii - 1 )*n + 1:ii*n) = Data(p - ii + 1:end - ii - loff + 1,:);
end
X = [ones(T,1) X];

%% forecasting evaluation periord
dates = dates(end-T+1:end);
T0 = find(round(dates,3) == round(startingdate,3));

%% store forecast estimates
% individual forecast estimates
yhat1  = zeros(T-1-T0+1,3,5);       %% h=1; 
yhat2  = zeros(T-2-T0+1,3,5);       %% h=2; 
yhat3  = zeros(T-3-T0+1,3,5);       %% h=3; 
yhat4  = zeros(T-4-T0+1,3,5);       %% h=4;
yhat5  = zeros(T-5-T0+1,3,5);       %% h=5; 
yhat6  = zeros(T-6-T0+1,3,5);       %% h=6; 
yhat7  = zeros(T-7-T0+1,3,5);       %% h=7; 
yhat8  = zeros(T-8-T0+1,3,5);       %% h=8; 
yhat9  = zeros(T-9-T0+1,3,5);       %% h=9
yhat10  = zeros(T-10-T0+1,3,5);     %% h=10; 
yhat11  = zeros(T-11-T0+1,3,5);     %% h=11; 
yhat12  = zeros(T-12-T0+1,3,5);     %% h=12;         
tempyhat1 = zeros(nsims,3,3);         
tempyhat2 = zeros(nsims,3,3);
tempyhat3 = zeros(nsims,3,3);
tempyhat4 = zeros(nsims,3,3);
tempyhat5 = zeros(nsims,3,3);
tempyhat6 = zeros(nsims,3,3);
tempyhat7 = zeros(nsims,3,3);
tempyhat8 = zeros(nsims,3,3);
tempyhat9 = zeros(nsims,3,3);
tempyhat10 = zeros(nsims,3,3);
tempyhat11 = zeros(nsims,3,3);
tempyhat12 = zeros(nsims,3,3);
% joint forecast estimates
Jyhat1  = zeros(T-1-T0+1,1);          %% h=1
Jyhat2  = zeros(T-2-T0+1,1);          %% h=2; 
Jyhat3  = zeros(T-3-T0+1,1);          %% h=3; 
Jyhat4  = zeros(T-4-T0+1,1);          %% h=4; 
Jyhat5  = zeros(T-5-T0+1,1);          %% h=5; 
Jyhat6  = zeros(T-6-T0+1,1);          %% h=6; 
Jyhat7  = zeros(T-7-T0+1,1);          %% h=7; 
Jyhat8  = zeros(T-8-T0+1,1);          %% h=8; 
Jyhat9  = zeros(T-9-T0+1,1);          %% h=9; 
Jyhat10  = zeros(T-10-T0+1,1);        %% h=10; 
Jyhat11  = zeros(T-11-T0+1,1);        %% h=11; 
Jyhat12 = zeros(T-12-T0+1,1);         %% h=12;  
Jtempyhat1 = zeros(nsims,1);
Jtempyhat2 = zeros(nsims,1);
Jtempyhat3 = zeros(nsims,1);
Jtempyhat4 = zeros(nsims,1);
Jtempyhat5 = zeros(nsims,1);
Jtempyhat6 = zeros(nsims,1);
Jtempyhat7 = zeros(nsims,1);
Jtempyhat8 = zeros(nsims,1);
Jtempyhat9 = zeros(nsims,1);
Jtempyhat10 = zeros(nsims,1);
Jtempyhat11 = zeros(nsims,1);
Jtempyhat12 = zeros(nsims,1);

%% priors
% A0 = zeros(k,n);
% invVA0 = 1/10*speye(k);
construct_prior_A;
invVA0 = VA0\speye(k);

nusigh = 10;
Ssigh = 0.01*(nusigh - 1);

phih0 = 0.9;
invVphih0 = 1/0.04;

nu0 = n + 2;
Sig0 = (nu0 - n - 1)*speye(n);


for t = T0:T-loff
    Tt = t;
    Xt = X(1:t,:);
    Yt = Y(1:t,:);
    
    %% initialize MCMC
    A = zeros(k,n);
    h = zeros(Tt,1);
    Sig = speye(n);
    phih = 0.9;
    sigh = 0.01;
    
    for isim = 1:nsims + burnin
        %% sample Sig and A
        invOmega = sparse(1:Tt,1:Tt,exp(-h));
        XinvOmega = Xt'*invOmega;
        KA = invVA0 + XinvOmega*Xt;
        Ahat = KA\(invVA0*A0 + XinvOmega*Yt);
        Shat = Sig0 + A0'*invVA0*A0 + Yt'*invOmega*Yt - Ahat'*KA*Ahat;
        Shat = (Shat+Shat')/2;  
        Sig = iwishrnd(Shat,nu0+Tt);    
        CSig = chol(Sig,'lower');
        A = Ahat + (chol(KA,'lower')'\randn(k,n))*CSig'; 

        %% sample 
        U = Yt - Xt*A;
        dY = (U/CSig');
        longdy = reshape(dY',[],1);
        h = SVAR_CSV(log(longdy.^2 + 0.0001) ,h, sigh, phih);

        %% sample phih
        g = @(x) 0.5*( 1 - x^2 ) - 0.5*h(1)^2/sigh*( 1 - x^2 );
        Dphih = 1/( invVphih0 + h(1:end-1)'*h(1:end-1)/sigh );
        phihat = Dphih*( h(1:end-1)'*h(2:end)/sigh  + invVphih0*phih0 );
        phihc = phihat + sqrt(Dphih)*randn;

        if abs(phihc) < 1
            logalp = g(phihc) - g(phih);
            if log(rand) < logalp
                phih = phihc;
            end
        end

        %% sample sigh
        pnusigh = nusigh + Tt/2;
        pSsigh =  0.5*(1 - phih^2)*h(1)^2 + 0.5*sum( ( h(2:end)-phih*h(1:end-1) ).^2 ) + Ssigh;
        sigh = 1/gamrnd(pnusigh, 1/pSsigh);
        
        if isim>burnin
            i = isim-burnin;
            
            %%%%%%%%%%%%%% store forecast estimates
            fX1 = X(t+loff,:); fX2 = X(t+loff,:);
            fh1 = h(end); fh2 = h(end);
            
            for count = 1:loff
                fh1 = phih*fh1 + sqrt(sigh)*randn;
            end
            fSig1 = exp(fh1).*Sig;
            ym1 = (fX1*A)';
            yhat_1 = ym1 + chol(fSig1, 'lower')*randn(n,1);
            fX1 = [1 yhat_1' fX1(2:end-n)];
            yhat_c1 = yhat_1(1:3);

            for count = 1:loff
                fh2 = phih*fh2 + sqrt(sigh)*randn;
            end
            fSig2 = exp(fh2).*Sig;
            ym2 = (fX2*A)';
            yhat_2 = ym2 + chol(fSig2, 'lower')*randn(n,1);
            fX2 = [1 yhat_2' fX2(2:end-n)];
            yhat_c2 = yhat_2(1:3);

            crps1 = abs(yhat_c1 - Y(t+loff,1:3)') - .5*abs(yhat_c1 - yhat_c2);
            tempyhat1(i,:,:) = [yhat_c1(1:3) normpdf( Y(t+loff,1:3)', ym1(1:3), sqrt(diag(fSig1(1:3,1:3))) )  crps1];
            Jtempyhat1(i) = mvnpdf( Y(t+loff,1:3), ym1(1:3)', fSig1(1:3,1:3) );
        end

        if ( mod( isim, 1000 ) == 0 )
            disp(  [ num2str( nsims + burnin - isim ) ' MCMC iterations remained... ' ] )
        end 

    end
    %%%%%%%%%%%%%%% compute forecast estimates
    yhat1(t-T0+1,:,:) = [Y(t+loff,1:3)' reshape(mean(tempyhat1(:,:,1)),[],1)  reshape(log(mean(tempyhat1(:,:,2))),[],1) reshape(median(tempyhat1(:,:,1)),[],1) reshape(mean(tempyhat1(:,:,3)),[],1)];
    Jyhat1(t-T0+1) = log(mean(Jtempyhat1)); 
    
    if ( mod( t, 1 ) == 0 )
        disp(  [ num2str( T-1-t ) ' forecast loops remained ........ ' ] ) 
    end 
end

RMSFE = zeros(3,12);
ALPS = zeros(3,12);
MAE = zeros(3,12);
ACRPS = zeros(3,12);

disp('...........Root Mean Square Forecast Errors(mean)................. ')
RMSFE(:,1) = sqrt(mean((yhat1(:,:,1) - yhat1(:,:,2)).^2, 1))';
RMSFE(:,2) = sqrt(mean((yhat2(:,:,1) - yhat2(:,:,2)).^2, 1))';
RMSFE(:,3) = sqrt(mean((yhat3(:,:,1) - yhat3(:,:,2)).^2, 1))';
RMSFE(:,4) = sqrt(mean((yhat4(:,:,1) - yhat4(:,:,2)).^2, 1))';
RMSFE(:,5) = sqrt(mean((yhat5(:,:,1) - yhat5(:,:,2)).^2, 1))';
RMSFE(:,6) = sqrt(mean((yhat6(:,:,1) - yhat6(:,:,2)).^2, 1))';
RMSFE(:,7) = sqrt(mean((yhat7(:,:,1) - yhat7(:,:,2)).^2, 1))';
RMSFE(:,8) = sqrt(mean((yhat8(:,:,1) - yhat8(:,:,2)).^2, 1))';
RMSFE(:,9) = sqrt(mean((yhat9(:,:,1) - yhat9(:,:,2)).^2, 1))';
RMSFE(:,10) = sqrt(mean((yhat10(:,:,1) - yhat10(:,:,2)).^2, 1))';
RMSFE(:,11) = sqrt(mean((yhat11(:,:,1) - yhat11(:,:,2)).^2, 1))';
RMSFE(:,12) = sqrt(mean((yhat12(:,:,1) - yhat12(:,:,2)).^2, 1))';
RMSFE

disp('...............Average Log Predictive likelihoods................. ')
ALPS(:,1) = mean(yhat1(:,:,3),1)';
ALPS(:,2) = mean(yhat2(:,:,3),1)';
ALPS(:,3) = mean(yhat3(:,:,3),1)';
ALPS(:,4) = mean(yhat4(:,:,3),1)';
ALPS(:,5) = mean(yhat5(:,:,3),1)';
ALPS(:,6) = mean(yhat6(:,:,3),1)';
ALPS(:,7) = mean(yhat7(:,:,3),1)';
ALPS(:,8) = mean(yhat8(:,:,3),1)';
ALPS(:,9) = mean(yhat9(:,:,3),1)';
ALPS(:,10) = mean(yhat10(:,:,3),1)';
ALPS(:,11) = mean(yhat11(:,:,3),1)';
ALPS(:,12) = mean(yhat12(:,:,3),1)';
ALPS

disp('...............Mean Absolute Error(median)........................ ')
MAE(:,1) = mean(abs(yhat1(:,:,1) - yhat1(:,:,4)))';
MAE(:,2) = mean(abs(yhat2(:,:,1) - yhat2(:,:,4)))';
MAE(:,3) = mean(abs(yhat3(:,:,1) - yhat3(:,:,4)))';
MAE(:,4) = mean(abs(yhat4(:,:,1) - yhat4(:,:,4)))';
MAE(:,5) = mean(abs(yhat5(:,:,1) - yhat5(:,:,4)))';
MAE(:,6) = mean(abs(yhat6(:,:,1) - yhat6(:,:,4)))';
MAE(:,7) = mean(abs(yhat7(:,:,1) - yhat7(:,:,4)))';
MAE(:,8) = mean(abs(yhat8(:,:,1) - yhat8(:,:,4)))';
MAE(:,9) = mean(abs(yhat9(:,:,1) - yhat9(:,:,4)))';
MAE(:,10) = mean(abs(yhat10(:,:,1) - yhat10(:,:,4)))';
MAE(:,11) = mean(abs(yhat11(:,:,1) - yhat11(:,:,4)))';
MAE(:,12) = mean(abs(yhat12(:,:,1) - yhat12(:,:,4)))';
MAE

disp('............Average Continous Ranked Probability Score............ ')
ACRPS(:,1) = mean(yhat1(:,:,5))';
ACRPS(:,2) = mean(yhat2(:,:,5))';
ACRPS(:,3) = mean(yhat3(:,:,5))';
ACRPS(:,4) = mean(yhat4(:,:,5))';
ACRPS(:,5) = mean(yhat5(:,:,5))';
ACRPS(:,6) = mean(yhat6(:,:,5))';
ACRPS(:,7) = mean(yhat7(:,:,5))';
ACRPS(:,8) = mean(yhat8(:,:,5))';
ACRPS(:,9) = mean(yhat9(:,:,5))';
ACRPS(:,10) = mean(yhat10(:,:,5))';
ACRPS(:,11) = mean(yhat11(:,:,5))';
ACRPS(:,12) = mean(yhat12(:,:,5))';
ACRPS




[mean(Jyhat1) mean(Jyhat2) mean(Jyhat3) mean(Jyhat4) mean(Jyhat5) mean(Jyhat6) mean(Jyhat7) mean(Jyhat8) mean(Jyhat9) mean(Jyhat10) mean(Jyhat11) mean(Jyhat12)]












