%% load data

load freddata_Q.mat

%% data from 1960:3 - 2016:3
t0 = find(dates == 1960 + 1/4);  %% 1960Q1
t1 = find(dates == 2015 + 3/4);  %% 2015Q3
dates = dates(t0:t1);
data = data(t0:t1,:);

%% delete missing data
[row, col] = find(isnan(data));
data(:,col) = [];
names(col) = [];

%% core and other variables
% core variables:  
% 1) PCEPI: CPI inflation rate; 
% 2) INDPRO: GDP growth; 
% 3) FEDFUNDS: effective Federal Funds Rate
id_core1 = find(ismember(names, {'CPIAUCSL'}));
id_core2 = find(ismember(names, {'GDPC96'}));
id_core3 = find(ismember(names, {'FEDFUNDS'}));
Ycore = data(:, [id_core1 id_core2 id_core3]);

% other variables
id_others = find( ~ismember(names, {'CPIAUCSL', 'GDPC96', 'FEDFUNDS'}));
Yothers = data(:, id_others); 
names_Yothers = names(id_others);
% 
id_others1 = find(ismember(names_Yothers, {'UNRATE'}));              % Civilian Unemployment Rate (56)
id_others2 = find(ismember(names_Yothers, {'INDPRO'}));              % Industrial Production Index (20)
id_others3 = find(ismember(names_Yothers, {'M2REALx'}));             %'M2REALx'(139)       % Real Mbase (137) 
id_others4 = find(ismember(names_Yothers, {'S&P 500'}));             % S&P's Common Stock Price Index: Composite (191)
Y4others = Yothers(:, [id_others1 id_others2 id_others3 id_others4]);
