function [Y_all, X_all, W_all, idi, idj, idw] ...
    = construct_data( Ycore, Yothers, T, n, p, loff, kgam, m_all )
%% construct Y, X, W for all models

% auxiliary constructors for W
idi = triu( repmat( 2:n, n - 1, 1 ) );
idi = reshape( idi, [], 1 );
idi( idi == 0 ) = [];
idj = ( 1:kgam )';
idw = triu( repmat( ( 1:n - 1 )', 1, n - 1 ) );
idw = reshape( idw, [], 1 );
idw( idw == 0 ) = [];

% allocate space for data
Y_all = cell( m_all, 1 );
X_all = cell( m_all, 1 );
W_all = cell( m_all, 1 );

parfor mi = 1:m_all
    % construct Y, X
    Data = [Ycore Yothers( :, mi )];
    Y = Data( p + loff:end, : );
    X = zeros( T, n * p );
    W = []; % needs to be predefined for parfor construction
    for ii = 1:p
        X( :, ( ii - 1 ) * n + 1:ii * n ) = Data( p - ii + 1:end - ii - loff + 1, : ); 
    end
    X = [ones( T, 1 ) X];

    % construct W
    for ii = 1:T 
        if ii == 1
            wt = Y( ii, : );
            W = -sparse( idi, idj, wt( idw ), n, kgam );
        else
            wt = Y( ii, : );
            tempWt = -sparse( idi, idj, wt( idw ), n, kgam );
            W = blkdiag( W, tempWt );
        end
    end
    
    Y_all{mi} = Y;
    X_all{mi} = X;
    W_all{mi} = W;
end
