function V = recover_V( g_core, h_core, kgam_core, ncore, T, nsims )

% preconstruct useful indices
icov = triu( repmat( 2:ncore, ncore - 1, 1 ) );
icov = reshape( icov, [], 1 );
icov( icov == 0 ) = [];
jcov = triu( repmat( ( 1: ncore - 1 )', 1, ncore - 1 ) );
jcov = reshape( jcov, [], 1 );
jcov( jcov == 0 ) = [];

V = zeros( nsims, ncore, ncore, T );
for isim = 1:nsims
    for t = 1:T
        gt = g_core( isim, ( t - 1 ) * kgam_core + 1:t * kgam_core )';
        ht = h_core( isim, ( t - 1  ) * ncore + 1:t * ncore )';
        iB = inv( speye( ncore ) + sparse( icov, jcov, gt, ncore, ncore ) );
        V( isim, :, :, t ) = iB * diag( exp( ht ) ) * iB';
    end
end