function doparallel = setup_parpool( doparallel )
%% set up parallel processing if requested

if nargin < 1
    doparallel = true;
end

if doparallel
    if exist( 'parpool' ) && isempty( gcp )
        parpool; % start a new parallel pool if not already running
    elseif exist( 'matlabpool' ) && matlabpool( 'size' ) == 0
        matlabpool; % start a new parallel pool if not already running
    elseif ~exist( 'parpool' ) && ~exist( 'matlabpool' )
        % no parallel computing functionality exists
        doparallel = false;
    end
end
